#define COLORDEPTH 255
#define COLOREXTEN 765

#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <libsx.h>
#include <ctype.h>
#include <time.h>

#include "pixmaps.h"
#include "config.h"
#include "help.h"
#include "bd_help.h"

char sis_z[256] = "sis-proc.c";

char sis_basedir[256] = SISDIR ;
/* char editor_cmd[256] = "xterm -geometry 80x32"
                       " -vb -ms red -cr green -fn 10x20 -e microemacs"; */
char editor_cmd[256] = "emacs -geometry 80x32 -bg lightyellow "
                       "-ms red -cr green -fn 9x15";
char img_viewer_cmd[256] = "display";
char stereograph_cmd[256] = "stereograph -w 95 -A -f ppm";
char pager_cmd[256] = "xless -geometry 80x36 -fn 9x15";

char rcfile[256];
char msg_popup_title[80];

Widget pixmap1, pixmap2, pixmap3, pixmap4;
Widget wid_main[10], wid_label[4];
Widget wid_config[15];
Widget BD, BDtitle, wid_BD[30];
Widget wid_WH[6];
int num_ptr[5];
int popup_width, popup_height;

char title_str[256]="";
char width_str[80]="";
char height_str[80]="";
char x1_str[80]="";
char x2_str[80]="";
char y1_str[80]="";
char y2_str[80]="";
char z1_str[80]="";
char z2_str[80]="";

void SelectTexture(Widget ww, void* data);
void ViewStereogram(Widget ww, void *data);

char *z_c_prog=NULL;

char depthmap[1024];
char texture[1024];
char mathfile[1024];
char depthmap_dir[1024];
char texture_dir[1024];
char mathfile_dir[1024];

void MsgPopupOkay(Widget ww, void* data)
{
  SetCurrentWindow(wid_WH[0]);
  CloseWindow();
}

void MsgPopup(Widget ww, void* data)
{
int i;

  wid_WH[0]=MakeWindow(msg_popup_title,
             SAME_DISPLAY, EXCLUSIVE_WINDOW);
  wid_WH[1]=MakeTextWidget((char *)data, 0,0,popup_width,popup_height);
  wid_WH[2]=MakeButton("Okay", MsgPopupOkay, NULL);
  SetWidgetPos(wid_WH[2],PLACE_UNDER,wid_WH[1],NO_CARE,NULL);

  ShowDisplay();
  SetBgColor(wid_WH[1],INPUTBG);
  SetBgColor(wid_WH[2],BUTTONBG);
  MainLoop();
}

void CfgOK(Widget ww, void* data)
{
FILE *fd;
char line[1024]; 

   SetCurrentWindow(wid_config[0]);
   CloseWindow();

   strcpy(sis_basedir,GetStringEntry(wid_config[6]));
   strcpy(stereograph_cmd,GetStringEntry(wid_config[7]));
   strcpy(editor_cmd,GetStringEntry(wid_config[8]));
   strcpy(pager_cmd,GetStringEntry(wid_config[9]));
   strcpy(img_viewer_cmd,GetStringEntry(wid_config[10]));

   fd = fopen(rcfile, "w");
   if (fd == NULL) return;

   if (*sis_basedir)
     {
     sprintf(line, "SISDIR: %s\n", sis_basedir); fputs(line, fd);
     }
   if (*stereograph_cmd)
     {
     sprintf(line, "STEREOGRAPH: %s\n", stereograph_cmd); fputs(line, fd);
     }

   if (*editor_cmd)
     {
     sprintf(line, "EDITCMD: %s\n", editor_cmd); fputs(line, fd);
     }
   if (*pager_cmd)
     {
     sprintf(line, "PAGERCMD: %s\n", pager_cmd); fputs(line, fd);
     }
   if (*img_viewer_cmd)
     {
     sprintf(line, "IMGVIEWER: %s\n", img_viewer_cmd); fputs(line, fd);
     }
   fclose(fd);
}

void CfgCancel(Widget ww, void* data)
{
   SetCurrentWindow(wid_config[0]);
   CloseWindow();
}

void Config(Widget ww, void* data)
{
int i;

   wid_config[0] = MakeWindow("Configuration",SAME_DISPLAY, EXCLUSIVE_WINDOW);
   wid_config[1] = MakeLabel("SIS base directory ");
   wid_config[2] = MakeLabel("Stereograph command");
   wid_config[3] = MakeLabel("Editor command     ");
   wid_config[4] = MakeLabel("Pager command      ");
   wid_config[5] = MakeLabel("Image viewer       ");
   wid_config[6] = MakeTextWidget(sis_basedir, 0,1,600,50);
   wid_config[7] = MakeTextWidget(stereograph_cmd, 0,1,600,50);
   wid_config[8] = MakeTextWidget(editor_cmd, 0,1,600,50);
   wid_config[9] = MakeTextWidget(pager_cmd, 0,1,600,50);
   wid_config[10] = MakeTextWidget(img_viewer_cmd, 0,1,600,50);
   wid_config[11] = MakeButton("OK", CfgOK, NULL);
   wid_config[12] = MakeButton("Cancel", CfgCancel, NULL);

   for (i=2; i<=5; i++)
     SetWidgetPos(wid_config[i],PLACE_UNDER,wid_config[i+4],NO_CARE,NULL);
   for (i=6; i<=10; i++)
     SetWidgetPos(wid_config[i],PLACE_UNDER,wid_config[i-5],NO_CARE,NULL);

   for (i=11; i<=12; i++)
     {
     SetWidgetPos(wid_config[i],PLACE_UNDER,wid_config[10],NO_CARE,NULL);
     if(i>11) SetWidgetPos(wid_config[i],PLACE_RIGHT,wid_config[i-1],NO_CARE,NULL);
     }

   ShowDisplay();
   for (i=1; i<=5; i++) SetFgColor(wid_config[i],BLUE);
   for (i=6; i<=10; i++) SetBgColor(wid_config[i],INPUTBG);
   for (i=11; i<=12; i++) SetBgColor(wid_config[i],BUTTONBG);
   MainLoop();
}

void BDCancel(Widget ww, void* data)
{
   SetCurrentWindow(BD);
   CloseWindow();
}

void BDWrite(char *filename)
{
FILE *fd;
char cmd[4096];

   fd = fopen(filename, "w");
   if (fd==NULL) return;
   fputs("/* ", fd);
   fputs(GetStringEntry(wid_BD[0]), fd);
   fputs(" */\n", fd);
   sprintf(cmd,"/* %s %s %s %s %s %s %s %s */\n\n",
       GetStringEntry(wid_BD[2]),
       GetStringEntry(wid_BD[4]),
       GetStringEntry(wid_BD[6]),
       GetStringEntry(wid_BD[8]),
       GetStringEntry(wid_BD[10]),
       GetStringEntry(wid_BD[12]),
       GetStringEntry(wid_BD[14]),
       GetStringEntry(wid_BD[16]));
   fputs(cmd, fd);
   fputs(GetStringEntry(wid_BD[18]), fd);
   fclose(fd);
}

void BDRead(char *filename)
{
FILE *fd;
char cmd[4096];
char *ptr;
struct stat buf;
int i,n;

   fd = fopen(filename, "r");
   if (fd==NULL) return;
   stat(filename, &buf);
   if(z_c_prog) free(z_c_prog);
   z_c_prog = (char *) malloc((buf.st_size+8)*sizeof(char));
   z_c_prog[0] = '\0';
   n = 0;
   while(!feof(fd))
   {
      ptr = fgets(cmd, 4090, fd);
      if(ptr) 
	{
        if (n==0) 
           {
           for(i=0;i<=1;i++) if(*ptr!='\0') ++ptr; 
           while(isspace(*ptr)) ++ptr;
           strcpy(title_str,ptr);
           ptr=title_str+strlen(title_str)-1;
           for(i=0;i<=2;i++) if(ptr>title_str) --ptr;
           while(isspace(*ptr) && ptr>title_str) --ptr;
           ++ptr;
           *ptr='\0';
	   }
        if (n==1) sscanf(ptr,"/* %s %s %s %s %s %s %s %s */", 
           width_str, height_str, 
           x1_str, x2_str, y1_str, y2_str, z1_str, z2_str);
        if (n>=3 || ((n==2) && strcmp(ptr,"\n")))
           strcat(z_c_prog,cmd);
        ++n;
	}
   }
   fclose(fd);
   SetStringEntry(wid_BD[0],title_str);
   SetStringEntry(wid_BD[2],width_str);
   SetStringEntry(wid_BD[4],height_str);
   SetStringEntry(wid_BD[6],x1_str);
   SetStringEntry(wid_BD[8],x2_str);
   SetStringEntry(wid_BD[10],y1_str);
   SetStringEntry(wid_BD[12],y2_str);
   SetStringEntry(wid_BD[14],z1_str);
   SetStringEntry(wid_BD[16],z2_str);
   SetStringEntry(wid_BD[18],z_c_prog);
}

void BDEdit(Widget ww, void* data)
{
FILE *fd;
char cmd[4096];

   BDWrite(sis_z);
   sprintf(cmd,"%s %s", editor_cmd, sis_z);
   system(cmd);
   BDRead(sis_z);
}

void BDEditor(Widget ww, void* data)
{
char *outstr;

   outstr = GetText("Editor command:", editor_cmd, 600, 100);
   if(outstr) strcpy(editor_cmd, outstr);
}

void BDLoad(Widget ww, void* data)
{
  char *output;
  char comment[1024];

  output= (char *)GetFile("Math C file to load", mathfile_dir,NULL,NULL);

  if(output==NULL || *output=='\0') return;
  if(strncmp(output,mathfile_dir,strlen(output)-1)==0) return;

  strcpy(mathfile,output);
  strcpy(mathfile_dir,output);
  output = mathfile_dir+strlen(mathfile_dir)-1;
  while(*output!='/' && output>mathfile_dir) --output;
  if(*output=='/') *output='\0';

  sprintf(comment, "echo -e \"Reading mathfile: %s\n\" >> sis-log ", mathfile);
  system(comment);
  BDRead(mathfile);
}

void BDSave(Widget ww, void* data)
{
  char *output;
  char comment[1024];
  FILE *fd;

  output= (char *)GetFile("Math C file to write", mathfile_dir,NULL,NULL);

  if(output==NULL || *output=='\0') return;


  strcpy(mathfile,output);
  strcpy(mathfile_dir,output);
  output = mathfile_dir+strlen(mathfile_dir)-1;
  while(*output!='/' && output>mathfile_dir) --output;
  if(*output=='/') *output='\0';
  fd = fopen(mathfile, "r");
  if(fd)
    {
    fclose(fd);
    sprintf(comment,"Are you really sure that you want to overwrite\n%s ??", 
        mathfile);
    if(!GetYesNo(comment)) return;
    }

  sprintf(comment, "echo -e \"Saving mathfile: %s\n\" >> sis-log ", mathfile);
  system(comment);
  BDWrite(mathfile);
}

void BDGenerate(Widget ww, void* data)
{
FILE *fd;

   fd = fopen("sis-depth.c", "w");

/* Building sis-depth.c program */
fprintf(fd, "\
#include <stdlib.h>\n\
#include <stdio.h>\n\
#include <math.h>\n\
\n\
#define PI 3.14159265358979\n\
#define COLORDEPTH %d\n\
#define COLOREXTEN %d\n\
#define WIDTH  %s\n\
#define HEIGHT %s\n\
\n\
typedef double point[3];\n\
\n\
typedef void (*BFunction)();\n\
typedef double (*ZFunction)(double x, double y);\n\
typedef void  (*PFunction)(point p, double x, double y);\n\
\n\
const double CONV_RAD=M_PI/180;\n\
int do_init = 1;\n\
short int pixel_color[WIDTH][HEIGHT];\n\
double x_1=%s, x_2=%s, y_1=%s, y_2=%s, z_1=%s, z_2=%s;\n\
double ratio_x, ratio_y, ratio_z;\n\
double m_rot[12]={1,0,0,0,0,1,0,0,0,0,1,0};\n\
\n\
double max(double x, double y)\n\
{\n\
   if(x>=y) return x; else return y;\n\
}\n\
\n\
double min(double x, double y)\n\
{\n\
   if(x>=y) return x; else return y;\n\
}\n\
\n\
void do_init_image()\n\
{\n\
int i,j;\n\
\n\
   if (do_init)\n\
     {\n\
     for(j=0; j<HEIGHT; j++) for(i=0; i<WIDTH; i++) pixel_color[i][j] = 0;\n\
     ratio_x = (x_2-x_1)/(double)WIDTH;\n\
     ratio_y = (y_2-y_1)/(double)HEIGHT;\n\
     if(ratio_x==0 || ratio_y==0) exit(1);\n\
     ratio_z = z_2-z_1;\n\
     if(ratio_z<=0) exit(1); else ratio_z = ((double)COLOREXTEN)/ratio_z;\n\
     do_init = 0;\n\
     }\n\
}\n\
\n\
void translation(double a, double b, double c)\n\
{\n\
   m_rot[3] = a;   \n\
   m_rot[7] = b;   \n\
   m_rot[11] = c;   \n\
}\n\
\n\
void scale(double a)\n\
{\n\
int i;\n\
\n\
   for (i=0; i<=11; i++) m_rot[i] *= a;   \n\
}\n\
\n\
void rotation_angles(double theta, double phi, double psi)\n\
{\n\
double ca,cb,cc, sa,sb,sc;\n\
\n\
   ca=theta*CONV_RAD;\n\
   cb=phi*CONV_RAD;\n\
   cc=psi*CONV_RAD;\n\
\n\
   sa=sin(ca); ca=cos(ca);\n\
   sb=sin(cb); cb=cos(cb);\n\
   sc=sin(cc); cc=cos(cc);\n\
\n\
   m_rot[0] = ca*cb;\n\
   m_rot[1] = -sa*cc-ca*sb*sc;\n\
   m_rot[2] = sa*sc-ca*sb*cc;\n\
\n\
   m_rot[4] = sa*cb;\n\
   m_rot[5] = ca*cc-sa*sb*sc;\n\
   m_rot[6] = -ca*sc-sa*sb*cc;\n\
\n\
   m_rot[8] = sb;\n\
   m_rot[9] = cb*sc;\n\
   m_rot[10]= cb*cc;\n\
\n\
}\n\
\n\
void rotate(point p, point q)\n\
{\n\
int i,j;\n\
   for(i=0; i<=2; i++)\n\
     {\n\
     j=4*i;\n\
     q[i] = m_rot[j]*p[0]+m_rot[j+1]*p[1]+m_rot[j+2]*p[2]+m_rot[j+3];\n\
     }\n\
}\n\
\n\
void setpoint(point p, point q)\n\
{\n\
int i;\n\
\n\
   for(i=0; i<=2; i++) p[i] = q[i];\n\
}\n\
\n\
void mesh(point *p, int h, int i, int j)\n\
{\n\
point a[3];\n\
double ca,cb,cc,cd, delta, s,t, adds,addt, x, y, z, z0,z1,z2;\n\
int u1, u2, v1, v2;\n\
int k,l,m;\n\
\n\
   do_init_image();\n\
   rotate(p[h],a[0]);\n\
   rotate(p[i],a[1]);\n\
   rotate(p[j],a[2]);\n\
\n\
   u1=WIDTH; u2=-1;\n\
   v1=HEIGHT; v2=-1;\n\
\n\
   for(k=0; k<=2; k++)\n\
     {\n\
     l=(int)((a[k][0]-x_1)/ratio_x);\n\
     if(l<u1) u1=l;\n\
     if(l>u2) u2=l;\n\
     l=(int)((y_2-a[k][1])/ratio_y);\n\
     if(l<v1) v1=l;\n\
     if(l>v2) v2=l;\n\
     }\n\
\n\
    if(u1<0) u1=0;\n\
    if(u2>=WIDTH) u2=WIDTH-1;\n\
    if(v1<0) v1=0;\n\
    if(v2>=HEIGHT) v2=HEIGHT-1;\n\
    if(u1>u2 || v1>v2) return;\n\
\n\
    z0 = a[0][2];\n\
    z1 = a[1][2]-z0;\n\
    z2 = a[2][2]-z0;\n\
\n\
    z0 = (z0-z_1)*ratio_z;\n\
    z1 = z1*ratio_z;\n\
    z2 = z2*ratio_z;\n\
\n\
    delta = (a[1][0]-a[0][0])*(a[2][1]-a[0][1]) \n\
                      - (a[1][1]-a[0][1])*(a[2][0]-a[0][0]);\n\
    if (fabs(delta)<1E-5) return;\n\
    \n\
    delta=1/delta;\n\
    ca = (a[2][1]-a[0][1])*delta;\n\
    cb = (a[0][0]-a[2][0])*delta;\n\
    cc = (a[0][1]-a[1][1])*delta;\n\
    cd = (a[1][0]-a[0][0])*delta;\n\
    adds = ca*ratio_x;\n\
    addt = cc*ratio_x;\n\
\n\
    for(l=v1; l<=v2; l++) \n\
      {\n\
      x = x_1 + u1*ratio_x - a[0][0];\n\
      y = y_2 - l*ratio_y - a[0][1];\n\
      s = ca*x + cb*y;\n\
      t = cc*x + cd*y;\n\
      for(k=u1; k<=u2; k++)\n\
	{\n\
        if (s>=-0.0001 && t>=-0.0001 && s+t<=1.0001)\n\
	  {\n\
          m = (int) (z0 + s*z1 + t*z2);\n\
          if (m<0) m=0;\n\
          if (m>COLOREXTEN) m=COLOREXTEN;\n\
          if (m>pixel_color[k][l]) pixel_color[k][l] = m;\n\
	  }\n\
        s = s + adds;\n\
        t = t + addt;\n\
        }\n\
      }\n\
}\n\
\n\
void build(BFunction bfunct)\n\
{\n\
   do_init_image();\n\
   bfunct();\n\
}\n\
\n\
void light(ZFunction zfunct)\n\
{\n\
int i, j;\n\
int k;\n\
double x,y;\n\
\n\
   do_init_image();\n\
\n\
   for(j=0; j<HEIGHT; j++) \n\
   {\n\
     y = y_2-ratio_y*j;\n\
     for(i=0; i<WIDTH; i++)\n\
     {\n\
        x = ratio_x*i+x_1;\n\
        k = (int)((zfunct(x,y)-z_1)*ratio_z);\n\
        if (k<0) k=0;\n\
        if (k>COLOREXTEN) k=COLOREXTEN;\n\
        if (k>pixel_color[i][j]) pixel_color[i][j] = k;\n\
     }\n\
   }\n\
}\n\
\n\
void graph(PFunction pfunct, double xi, double xs, int nx, \n\
                             double yi, double ys, int ny)\n\
{\n\
int i, j, l;\n\
double hx,hy;\n\
point p[4];\n\
\n\
   if(nx<=0 || ny<=0) return;\n\
\n\
   do_init_image();\n\
\n\
   hx = (xs-xi)/nx;\n\
   hy = (ys-yi)/ny;\n\
\n\
   for(j=0; j<ny; j++) \n\
     {\n\
     for(l=0; l<=1; l++)\n\
         pfunct(p[l],xi,yi+(j+l)*hy);\n\
\n\
     for(i=1; i<=nx; i++)\n\
         {\n\
         setpoint(p[2],p[0]); setpoint(p[3],p[1]); \n\
         for(l=0; l<=1; l++)\n\
            pfunct(p[l], xi+i*hx,yi+(j+l)*hy);\n\
         mesh(p,0,1,2); mesh(p,1,2,3);\n\
         }\n\
     }\n\
}\n\
\n\
int main(int argc, char **argv)\n\
{\n\
int i, j;\n\
\n\
   %s\n\
\n\
   printf(\"P6\\n# CREATOR: sis\\n\");\n\
   printf(\" %%d %%d %%d\\n\", WIDTH, HEIGHT, COLORDEPTH);\n\
\n\
   for(j=0; j<HEIGHT; j++) for(i=0; i<WIDTH; i++)\n\
     {\n\
     int k=pixel_color[i][j]/3;\n\
     int l=pixel_color[i][j] - 3*k;\n\
     int m=0;\n\
     if (l==2) {l=1; m=1;}\n\
     printf(\"%%c%%c%%c\", k, k+l, k+m);\n\
     }\n\
}\n\
",
COLORDEPTH,
COLOREXTEN,
GetStringEntry(wid_BD[2]),
GetStringEntry(wid_BD[4]),
GetStringEntry(wid_BD[6]),
GetStringEntry(wid_BD[8]),
GetStringEntry(wid_BD[10]),
GetStringEntry(wid_BD[12]),
GetStringEntry(wid_BD[14]),
GetStringEntry(wid_BD[16]),
GetStringEntry(wid_BD[18])
);
/* End of sis-depth.c program! */
  
   fclose(fd);
   
   system("gcc -lm sis-depth.c -o sis-depth ;\n"
          "./sis-depth | pnmtopng - > sis-depthmap.png ;\n"
          "rm -f core sis-depth.c sis-depth\n");
}

void BDView(Widget ww, void* data)

{
FILE *fd;
char cmd[512];

   fd=fopen("sis-depthmap.png", "r");
   if(fd) 
     fclose(fd);
   else
     BDGenerate(ww, NULL);

   sprintf(cmd,"if [ -r sis-depthmap.png ]; then %s sis-depthmap.png & fi\n",
               img_viewer_cmd);
   system(cmd);
}

void BDView3D(Widget ww, void* data)
{
FILE *fd;

   fd=fopen("sis-depthmap.png", "r");
   if(fd==NULL) 
     {
     BDGenerate(ww, NULL);
     fd=fopen("sis-depthmap.png", "r");
     }

   if(fd) 
     {
     fclose(fd);
     sprintf(depthmap,"%s/%s",get_current_dir_name(),"sis-depthmap.png");
     ViewStereogram(ww,NULL);
     }
}   

void BDOk(Widget ww, void* data)
{
char *ptr;
FILE *fd;

   ptr = GetStringEntry(wid_BD[0]);
   if(ptr) 
     strcpy(title_str,ptr);

   ptr = GetStringEntry(wid_BD[2]);
   if(ptr) 
     strcpy(width_str,ptr);

   ptr = GetStringEntry(wid_BD[4]);
   if(ptr) 
     strcpy(height_str,ptr);

   ptr = GetStringEntry(wid_BD[6]);
   if(ptr) 
     strcpy(x1_str,ptr);

   ptr = GetStringEntry(wid_BD[8]);
   if(ptr) 
     strcpy(x2_str,ptr);

   ptr = GetStringEntry(wid_BD[10]);
   if(ptr) 
     strcpy(y1_str,ptr);

   ptr = GetStringEntry(wid_BD[12]);
   if(ptr) 
     strcpy(y2_str,ptr);

   ptr = GetStringEntry(wid_BD[14]);
   if(ptr) 
     strcpy(z1_str,ptr);

   ptr = GetStringEntry(wid_BD[16]);
   if(ptr) 
     strcpy(z2_str,ptr);

   ptr = GetStringEntry(wid_BD[18]);
   if(ptr) 
     {
     if(z_c_prog) free(z_c_prog);
     z_c_prog = (char *) malloc((strlen(ptr)+2)*sizeof(char));
     strcpy(z_c_prog,ptr);
     }

   SetCurrentWindow(BD);
   CloseWindow();
   
   fd=fopen("sis-depthmap.png", "r");
   if(fd)
     {
     sprintf(depthmap,"%s/%s",get_current_dir_name(),"sis-depthmap.png");
     fclose(fd);
     }
}

void BuildDepthmap(Widget ww, void* data)
{
int i;
 
   strcpy(msg_popup_title, "Modeller help");
   popup_width = 640;
   popup_height = 610;
   
   BD = MakeWindow("Depthmap Modeller",SAME_DISPLAY, EXCLUSIVE_WINDOW);
   BDtitle=MakeLabel("Title ");
   wid_BD[0]=MakeStringEntry(title_str, 360,NULL,NULL);
   wid_BD[1]=MakeLabel("Width ");
   wid_BD[2]=MakeStringEntry(width_str,60,NULL,NULL);
   wid_BD[3]=MakeLabel("     Height");
   wid_BD[4]=MakeStringEntry(height_str,60,NULL,NULL);
   SetWidgetPos(wid_BD[0],PLACE_RIGHT,BDtitle,NO_CARE,NULL);
   for(i=1;i<=4;i++)
     {
     SetWidgetPos(wid_BD[i],PLACE_UNDER,wid_BD[0],NO_CARE,NULL);
     if(i>1) SetWidgetPos(wid_BD[i],PLACE_RIGHT,wid_BD[i-1],NO_CARE,NULL);
     }
   wid_BD[5]=MakeLabel("x1");
   wid_BD[6]=MakeStringEntry(x1_str,100,NULL,NULL);
   wid_BD[7]=MakeLabel("     x2");
   wid_BD[8]=MakeStringEntry(x2_str,100,NULL,NULL);
   for(i=5;i<=8;i++)
     {
     SetWidgetPos(wid_BD[i],PLACE_UNDER,wid_BD[1],NO_CARE,NULL);
     if(i>5) SetWidgetPos(wid_BD[i],PLACE_RIGHT,wid_BD[i-1],NO_CARE,NULL);
     }
   wid_BD[9]=MakeLabel("y1");
   wid_BD[10]=MakeStringEntry(y1_str,100,NULL,NULL);
   wid_BD[11]=MakeLabel("     y2");
   wid_BD[12]=MakeStringEntry(y2_str,100,NULL,NULL);
   for(i=9;i<=12;i++)
     {
     SetWidgetPos(wid_BD[i],PLACE_UNDER,wid_BD[5],NO_CARE,NULL);
     if(i>9) SetWidgetPos(wid_BD[i],PLACE_RIGHT,wid_BD[i-1],NO_CARE,NULL);
     }
   wid_BD[13]=MakeLabel("z1");
   wid_BD[14]=MakeStringEntry(z1_str,100,NULL,NULL);
   wid_BD[15]=MakeLabel("     z2");
   wid_BD[16]=MakeStringEntry(z2_str,100,NULL,NULL);
   for(i=13;i<=16;i++)
     {
     SetWidgetPos(wid_BD[i],PLACE_UNDER,wid_BD[9],NO_CARE,NULL);
     if(i>13) SetWidgetPos(wid_BD[i],PLACE_RIGHT,wid_BD[i-1],NO_CARE,NULL);
     }

   wid_BD[17]=MakeLabel("C procedure defining the object :");
   wid_BD[18]=MakeTextWidget(z_c_prog, 0,1,640,440);
   for(i=17;i<=18;i++)
     SetWidgetPos(wid_BD[i],PLACE_UNDER,wid_BD[i-1],NO_CARE,NULL);
   wid_BD[19]=MakeButton("Load", BDLoad, NULL);
   wid_BD[20]=MakeButton("Save", BDSave, NULL);
   wid_BD[21]=MakeButton("Edit",BDEdit,NULL);
   wid_BD[22]=MakeButton("Editor",BDEditor,NULL);
   wid_BD[23]=MakeButton("Generate",BDGenerate,NULL);
   wid_BD[24]=MakeButton("View",BDView,NULL);
   wid_BD[25]=MakeButton("Texture",SelectTexture,NULL);
   wid_BD[26]=MakeButton("3D image",BDView3D,NULL);
   wid_BD[27]=MakeButton("Help",MsgPopup,(void *)bd_help);
   wid_BD[28]=MakeButton("Okay",BDOk,NULL);
   wid_BD[29]=MakeButton("Cancel",BDCancel,NULL);

   for(i=19;i<=29;i++)
     {
     SetWidgetPos(wid_BD[i],PLACE_UNDER,wid_BD[18],NO_CARE,NULL);
     if(i>19) SetWidgetPos(wid_BD[i],PLACE_RIGHT,wid_BD[i-1],NO_CARE,NULL);
     }
   
   ShowDisplay();
   SetFgColor(wid_BD[0],BLUE);
   for (i=0; i<=10 ; i++) 
      SetBgColor(wid_BD[2*i],INPUTBG);
   for (i=19; i<=29 ; i++) 
      SetBgColor(wid_BD[i],BUTTONBG);
   MainLoop();
}

void Quit(Widget ww, void* data)
{
   system("rm -f core sis-*");
   exit(0);
}

void CloseProcedure(Widget ww)
{
   Quit(ww, NULL);
}


void ViewLog(Widget ww, void* data)
{
char cmd[512];

   sprintf(cmd,"%s -f sis-log &", pager_cmd);
   system(cmd);
}

void ShowSelection(Widget ww, void* data)
{
char selstring[1024];

  sprintf(selstring,"Depth map: %s\nTexture  : %s", depthmap, texture);
  strcpy(msg_popup_title,"Xstereograph: selected items");
  popup_width = 400; 
  popup_height = 50;
  MsgPopup(ww,selstring);
}

void SelectTexture(Widget ww, void* data)
{
  char *output;
  char comment[1024];

  output= (char *)GetFile("Texture file to load", texture_dir,NULL,NULL);
    
  if(output==NULL) return;

  if(*output=='\0' || !strncmp(output,texture_dir,strlen(output)-1))
    strcpy(texture,"-");
  else
    {
    strcpy(texture,output);
    strcpy(texture_dir,output);
    output = texture_dir+strlen(texture_dir)-1;
    while(*output!='/' && output>texture_dir) --output;
    if(*output=='/') *output='\0';
    }

  sprintf(comment, "echo -e \"Selecting texture: %s\n\" >> sis-log ", texture);
  system(comment);
}

void RandomizeTexture(Widget ww, void* data)
{
struct dirent *file;
DIR *textures;
unsigned long int count=0, larger, rand;
char comment[1024];

   textures = opendir(texture_dir);
   while((file = readdir(textures)) != NULL) count++;
   closedir(textures);

   count -= 2;
   larger = (count * 10)/7;
   rand = (random() + (unsigned long int) time(NULL)) % larger;
   if (rand >= count)
   {
      strcpy(texture,"-");
      return;
   }

   count = -2;
   textures = opendir(texture_dir);
   while((file = readdir(textures)) != NULL)
   {
      count++;
      if (count == rand)
         sprintf(texture, "%s/textures/%s", sis_basedir, file->d_name);
   }
   closedir(textures);

   sprintf(comment,"echo -e \"Randomizing texture: %s\n\" >> sis-log", texture);
   system(comment);
}

void SelectDepthmap(Widget ww, void* data)
{
  char *output;
  char comment[1024];

  output= (char *)GetFile("Depthmap file to load", depthmap_dir,NULL,NULL);
    
  if(output==NULL) return;

  if(*output=='\0' || !strncmp(output,depthmap_dir,strlen(output)-1))
    strcpy(depthmap,"-");
  else
    {
    strcpy(depthmap,output);
    strcpy(depthmap_dir,output);
    output = depthmap_dir+strlen(depthmap_dir)-1;
    while(*output!='/' && output>depthmap_dir) --output;
    if(*output=='/') *output='\0';
    }
    
  sprintf(comment,"echo -e \"Selecting depthmap: %s\n\" >> sis-log ", depthmap);
  system(comment);
}

void RandomizeDepthmap(Widget ww, void* data)
{
struct dirent *file;
DIR *depth_maps;
unsigned long int count=0, rand;
char comment[1024];

   depth_maps = opendir(depthmap_dir);
   while((file = readdir(depth_maps)) != NULL) count++;
   closedir(depth_maps);

   count -= 2;
   rand = (random() + (unsigned long int) time(NULL)) % count;

   count = -2;
   depth_maps = opendir(depthmap_dir);
   while((file = readdir(depth_maps)) != NULL)
   {
      count++;
      if (count == rand)
         sprintf(depthmap, "%s/depth_maps/%s", sis_basedir, file->d_name);
   }
   closedir(depth_maps);
   sprintf(comment,"echo -e \"Randomizing depthmap: %s\n\" >> sis-log ", depthmap);
   system(comment);
}

void ViewTexture(Widget ww, void* data)
{  
char cmd[1024];
char comment[1024];

   if (strcmp(texture, "-")==0) return;

   sprintf(cmd, "if [ -r %s ]; then %s %s & fi\n", 
                texture, img_viewer_cmd, texture);
   system(cmd);
   sprintf(comment,"echo -e \"Executing: %s\n\" >> sis-log", cmd);
   system(comment);
}

void ViewDepthmap(Widget ww, void* data)
{  
char cmd[1024];
char comment[1024];

   if (strcmp(depthmap, "-")==0) return;

   sprintf(cmd, "%s %s &", img_viewer_cmd, depthmap);
   system(cmd);
   sprintf(comment,"echo -e \"Executing: %s\n\" >> sis-log", cmd);
   system(comment);
}

void ViewStereogram(Widget ww, void* data)
{  
char cmd[2048];
char begincmd[1024];
char endcmd[256]; 

   if (strcmp(depthmap, "-")==0) 
   {
     RandomizeDepthmap(ww,NULL);
     if (strcmp(texture, "-")==0) RandomizeTexture(ww,NULL);
   }

   sprintf(begincmd, "echo -e \"Executing: stereograph\n"
                     "Depthmap: %s\nTexture map: %s\n\" >> sis-log",
                     depthmap, texture);
   sprintf(endcmd, "echo -e \"Executing: %s sis-out3D.ppm\n\" >> sis-log\n"
                   "%s sis-out3D.ppm", img_viewer_cmd, img_viewer_cmd);

   if(strcmp(texture,"-")==0)
     sprintf(cmd, 
       "( %s\n%s -C -b %s > sis-out3D.ppm 2>>sis-log \n %s ) &",
              begincmd, stereograph_cmd, depthmap, endcmd);
   else
     sprintf(cmd, 
  "( %s\n%s -b %s -t %s > sis-out3D.ppm 2>>sis-log \n %s ) &",
              begincmd, stereograph_cmd, depthmap, texture, endcmd);

   system(cmd);
}

void About(Widget ww, void* data)
{
char cmd[512];

   switch(*(int *)data)
   {
   case 0:
     strcpy(msg_popup_title,"Xstereograph help");
     popup_width = 640; 
     popup_height = 610;
     MsgPopup(ww,sis_help);
     break;

   case 1:
     sprintf(cmd, "%s %s/stereo_dia.png &", img_viewer_cmd, sis_basedir);
     system(cmd);
     break;

   case 2:
     sprintf(cmd, 
        "man stereograph | %s -title \"man stereograph\" &", pager_cmd);
     system(cmd);
     break;

   case 3:
     strcpy(msg_popup_title,"Copyright");
     popup_width = 400; 
     popup_height = 90;
     MsgPopup(ww,"Xstereograph is brought to you by J.-P.Demailly\n"
                 "Email: demailly@fourier.ujf-grenoble.fr\n"
                 "Copyright Universit de Grenoble I, France\n"
                 "Version 2.1, July 2000\n"
                 "Licensed under the General Public Licence\n"
                 "GPL -- The Free Software Foundation");
     break;

   default: 
     break;
   }
}

void ParseRcfile()
{
FILE *fd;
char *pline;
char line[1024];
int l;

   fd = fopen(rcfile, "r");
   if (fd == NULL)
     {
     fprintf(stderr, "No initialisation file ~/.sisrc . Using builtin defaults.\n");
     return ;
     }
   while((pline = fgets(line, 1020, fd)) != NULL)
     {
     if ((l = strlen(pline)-1) >=0 && pline[l]=='\n' ) pline[l]='\0';
     if ((pline = strstr(line, "SISDIR:")) != NULL)
        strcpy(sis_basedir, pline+8);
     if ((pline = strstr(line, "STEREOGRAPH:")) != NULL)
        strcpy(stereograph_cmd, pline+13);
     if ((pline = strstr(line, "EDITCMD:")) != NULL)
        strcpy(editor_cmd, pline+9);
     if ((pline = strstr(line, "PAGERCMD:")) != NULL)
        strcpy(pager_cmd, pline+10);
     if ((pline = strstr(line, "IMGVIEWER:")) != NULL)
        strcpy(img_viewer_cmd, pline+11);
     }
   fclose(fd);
}

/* callbacks for form widmask */

int main(int argc, char *argv[])
{
static char *args[] = { "-bg", "gray76", "-fn", "7x13bold", NULL };

int i, l, n;

   sprintf(rcfile, "%s/%s", getenv("HOME"), ".sisrc");
   strcpy(texture,"-");
   strcpy(depthmap,"-");
   sprintf(texture_dir,"%s/textures", sis_basedir);
   sprintf(depthmap_dir, "%s/depth_maps", sis_basedir);
   sprintf(mathfile_dir, "%s/mathfiles", sis_basedir);
   unlink("sis-log");
   unlink("sis-depthmap.png");

   PredefArgs= args;
   argc = OpenDisplay(argc, argv);
   if (argc == FALSE) return argc;

   ParseRcfile();

   pixmap1 = MakeLabel("");
   SetWidgetPixmap(pixmap1, magic_eye_xpm);
   wid_label[l=0] = MakeLabel("MagicEye SIS Generator  ");
   SetWidgetPos(wid_label[l],PLACE_RIGHT,pixmap1,NO_CARE,NULL);   
   wid_main[n=0] = MakeMenu("About ");
   for (i=0;i<=3;i++) num_ptr[i]=i;
   MakeMenuItem(wid_main[n], "Short help", About, (int *)&num_ptr[0]);
   MakeMenuItem(wid_main[n], "Optics", About, (int *)&num_ptr[1]);
   MakeMenuItem(wid_main[n], "Man page", About, (int *)&num_ptr[2]);
   MakeMenuItem(wid_main[n], "Copyright", About, (int *)&num_ptr[3]);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,pixmap1);
   wid_main[++n] = MakeButton("Config ", Config, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);  
   wid_main[++n] = MakeButton("Modeller", BuildDepthmap, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);
   /*   wid_main[++n] = MakeButton("Quit", Quit, data);
	SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);   */

   pixmap2 = MakeLabel("");
   SetWidgetPos(pixmap2,PLACE_UNDER,pixmap1,NO_CARE,NULL);
   SetWidgetPixmap(pixmap2, shapes_xpm);
   wid_label[++l] = MakeLabel("Magic object");
   SetWidgetPos(wid_label[l],PLACE_UNDER,pixmap1,PLACE_RIGHT,pixmap2);   
   wid_main[++n] = MakeButton("Select", SelectDepthmap, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,pixmap2);
   wid_main[++n] = MakeButton("Random ", RandomizeDepthmap, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);
   wid_main[++n] = MakeButton("Preview ", ViewDepthmap, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);

   pixmap3 = MakeLabel("");
   SetWidgetPos(pixmap3,PLACE_UNDER,pixmap2,NO_CARE,NULL);
   SetWidgetPixmap(pixmap3, cork_xpm);
   wid_label[++l] = MakeLabel("Texture");
   SetWidgetPos(wid_label[l],PLACE_UNDER,pixmap2,PLACE_RIGHT,pixmap3);   
   wid_main[++n] = MakeButton("Select", SelectTexture, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,pixmap3);
   wid_main[++n] = MakeButton("Random ", RandomizeTexture, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);
   wid_main[++n] = MakeButton("Preview ", ViewTexture, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);

   pixmap4 = MakeLabel("");
   SetWidgetPos(pixmap4,PLACE_UNDER,pixmap3,NO_CARE,NULL);
   SetWidgetPixmap(pixmap4, question_xpm);
   wid_label[++l] = MakeLabel("Stereogram");
   SetWidgetPos(wid_label[l],PLACE_UNDER,pixmap3,PLACE_RIGHT,pixmap4);   
   wid_main[++n] = MakeButton("Items ", ShowSelection, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,pixmap4);
   wid_main[++n] = MakeButton("Process", ViewLog, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);
   wid_main[++n] = MakeButton("3D image", ViewStereogram, NULL);
   SetWidgetPos(wid_main[n],PLACE_UNDER,wid_label[l],PLACE_RIGHT,wid_main[n-1]);

   ShowDisplay();
   GetStandardColors();
   HILIGHT=RED;
   INPUTBG=WHITE;
   BUTTONBG=GetNamedColor("Gray90");

   for(i=0;i<=l;i++) SetFgColor(wid_label[i],BLUE);
   for(i=0;i<=n;i++) SetBgColor(wid_main[i],BUTTONBG);

   MainLoop();

   return 0;
}
